VERSION 5.00
Object = "{A1F365CD-C4DA-44BC-B182-4495B8A753AB}#1.0#0"; "PISOCANCPM.ocx"
Begin VB.Form Form1 
   Caption         =   "Listen_Mode"
   ClientHeight    =   4065
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4845
   LinkTopic       =   "Form1"
   ScaleHeight     =   4065
   ScaleWidth      =   4845
   StartUpPosition =   3  'Windows Default
   Begin PISOCANCPMLib.PISOCANCPM PISOCANCPM 
      Left            =   3120
      Top             =   0
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   794
      _StockProps     =   0
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   3960
      Top             =   0
   End
   Begin VB.ListBox List_EntryData 
      Height          =   2595
      Left            =   120
      TabIndex        =   11
      Top             =   1320
      Width           =   4575
   End
   Begin VB.CommandButton Btn_LoadEDS 
      Caption         =   "Load EDS"
      Height          =   375
      Left            =   3720
      TabIndex        =   5
      Top             =   840
      Width           =   975
   End
   Begin VB.CommandButton Btn_AddNode 
      Caption         =   "Add Node"
      Height          =   375
      Left            =   2760
      TabIndex        =   4
      Top             =   840
      Width           =   975
   End
   Begin VB.CommandButton Btn_Initial 
      Caption         =   "Initial Master"
      Height          =   375
      Left            =   2760
      TabIndex        =   2
      Top             =   360
      Width           =   1935
   End
   Begin VB.CommandButton Btn_Remove 
      Caption         =   "Remove Node"
      Height          =   375
      Left            =   2760
      TabIndex        =   6
      Top             =   840
      Width           =   1935
   End
   Begin VB.CommandButton Btn_Shutdown 
      Caption         =   "Shutdown"
      Height          =   375
      Left            =   2760
      TabIndex        =   7
      Top             =   360
      Width           =   1935
   End
   Begin VB.ComboBox Combo_Node 
      Height          =   315
      ItemData        =   "Form1.frx":0000
      Left            =   1080
      List            =   "Form1.frx":0181
      TabIndex        =   3
      Top             =   840
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Baud 
      Height          =   315
      ItemData        =   "Form1.frx":046C
      Left            =   1080
      List            =   "Form1.frx":0488
      TabIndex        =   1
      Top             =   480
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Board 
      Height          =   315
      ItemData        =   "Form1.frx":04EE
      Left            =   1080
      List            =   "Form1.frx":0522
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Node ID"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   840
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Board No"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim BoardNo As Byte
Dim Port As Byte
Dim BAUD As Byte
Dim Node As Byte
Dim ISADD(128) As Byte

Const BlockMode As Byte = 1

Dim DelayTime As Integer
Dim Ret As Integer
Dim errstr As String

Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Sub Btn_AddNode_Click()
    Dim EntryUse As Byte
    Dim PDOId As Integer, i As Integer, j As Integer
    Dim EntryData(8) As Long

    Ret = PISOCANCPM.AddNode(BoardNo, Port, Node, 2, DelayTime, 200, BlockMode)
    If Ret <> 0 Then
        errstr = "AddNode Error, = " + Str(Ret)
        MsgBox (errstr)
    Else
        ISADD(Node) = 1

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_LoadEDS.Enabled = False
        Btn_LoadEDS.Visible = False
        Btn_Remove.Enabled = True

        ' Set EMCY ID to master list
        Call PISOCANCPM.SetEMCYList(BoardNo, Port, Node, (&H80 + Node), BlockMode)

        ' Install RxPDO to master PDO list
        For i = 0 To 3
            PDOId = &H200 + Node + (&H100 * i)

            If i = 0 Then
                EntryUse = 8
            Else
                EntryUse = 4
            End If

            For j = 0 To (EntryUse - 1)
                If i = 0 Then
                    EntryData(j) = &H62000108 + (&H100 * j)
                Else
                    EntryData(j) = &H64110110 + (&H100 * (j + ((i - 1) * EntryUse)))
                End If
            Next j

            Call PISOCANCPM.InstallPDOList(BoardNo, Port, Node, PDOId, 0, i + 1, 255, 0, EntryUse, EntryData(0), BlockMode)
        Next i

        ' Install TxPDO to master PDO list
        For i = 0 To 3
            PDOId = &H180 + Node + (&H100 * i)

            If i = 0 Then
                EntryUse = 8
            Else
                EntryUse = 4
            End If

            For j = 0 To (EntryUse - 1)
                If i = 0 Then
                    EntryData(j) = &H60000108 + (&H100 * j)
                Else
                    EntryData(j) = &H64010110 + (&H100 * (j + ((i - 1) * EntryUse)))
                End If
            Next j

            Call PISOCANCPM.InstallPDOList(BoardNo, Port, Node, PDOId, 1, i + 1, 255, 0, EntryUse, EntryData(0), BlockMode)
        Next i
    End If
End Sub

Private Sub Btn_Initial_Click()

    Ret = PISOCANCPM.InitMaster(BoardNo, Port, 0, BAUD, BlockMode)
    If Ret <> 0 Then
        errstr = "Initial Error, = " + Str(Ret)
        MsgBox (errstr)
    Else
        Combo_Board.Enabled = False
        Combo_Baud.Enabled = False
        Combo_Node.Enabled = True

        Btn_Initial.Enabled = False
        Btn_Initial.Visible = False
        Btn_Shutdown.Enabled = True

        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
        Btn_LoadEDS.Enabled = True
        Btn_LoadEDS.Visible = True

        ' Set to listen mode
        Call PISOCANCPM.SetMasterMode(BoardNo, Port, 1, BlockMode)

        Timer1.Enabled = True

    End If
End Sub

Private Sub Btn_LoadEDS_Click()
    Dim EDSFile As OPENFILENAME
    Dim EDSFilter As String
    Dim Ret As Long
    
    EDSFile.lStructSize = Len(EDSFile)
    EDSFile.hwndOwner = Form1.hWnd
    EDSFile.hInstance = App.hInstance
    EDSFile.lpstrFilter = "EDS files (*.eds)" & Chr(0) & "*.eds" & Chr(0)
    EDSFile.nFilterIndex = 1
    EDSFile.lpstrFile = String(257, 0)
    EDSFile.nMaxFile = Len(EDSFile.lpstrFile) - 1
    EDSFile.lpstrFileTitle = EDSFile.lpstrFile
    EDSFile.lpstrTitle = "Select EDS File of CANopen Slave Device"
    EDSFile.flags = 0
    
    Ret = GetOpenFileName(EDSFile)
    If (Ret <> 0) Then
        Ret = PISOCANCPM.EDSLoad(BoardNo, Port, Node, EDSFile.lpstrFile, DelayTime, 200, BlockMode)
        If (Ret <> 0) Then
            MsgBox ("EDS File Load Error = " + Str(Ret))
            Return
        End If
    Else
        ISADD(Node) = 1

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_LoadEDS.Enabled = False
        Btn_LoadEDS.Visible = False
        Btn_Remove.Enabled = True
    End If
End Sub

Private Sub Btn_Remove_Click()
    Ret = PISOCANCPM.RemoveNode(BoardNo, Port, Node, BlockMode)
    If Ret <> 0 Then
        errstr = "RemoveNode Error, = " + Str(Ret)
        MsgBox (errstr)
    Else
        ISADD(Node) = 0

        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
        Btn_LoadEDS.Enabled = True
        Btn_LoadEDS.Visible = True
        Btn_Remove.Enabled = False

        Call List_EntryData.Clear
    End If
End Sub

Private Sub Btn_Shutdown_Click()
    Dim i As Integer

    Ret = PISOCANCPM.ShutdownMaster(BoardNo, Port)
    If Ret <> 0 Then
        errstr = "Shutdown Error, = " + Str(Ret)
        MsgBox (errstr)
    Else
        Combo_Board.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Combo_Baud.ListIndex = 0

        Btn_Initial.Enabled = True
        Btn_Initial.Visible = True
        Btn_Shutdown.Enabled = False

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_LoadEDS.Enabled = False
        Btn_LoadEDS.Visible = True
        Btn_Remove.Enabled = False

        For i = 0 To 128
            ISADD(i) = 0
        Next

        Call List_EntryData.Clear

        Timer1.Enabled = False

    End If
End Sub

Private Sub Combo_Baud_LostFocus()
    BAUD = Combo_Baud.ListIndex

    Select Case (BAUD)
        Case 0
            DelayTime = 15
        Case 1
            DelayTime = 7
        Case 2
            DelayTime = 3
        Case 3
        Case 4
            DelayTime = 1
        Case 5
        Case 6
        Case 7
            DelayTime = 0
    End Select
End Sub

Private Sub Combo_Board_LostFocus()
    BoardNo = Combo_Board.ListIndex
End Sub

Private Sub Combo_Node_LostFocus()
    Node = Combo_Node.ListIndex + 1

    If ISADD(Node) = 1 Then
        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_LoadEDS.Enabled = False
        Btn_LoadEDS.Visible = False
        Btn_Remove.Enabled = True

        Call UpdateList
    ElseIf ISADD(Node) = 0 Then
        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
        Btn_LoadEDS.Enabled = True
        Btn_LoadEDS.Visible = True
        Btn_Remove.Enabled = False

        Call List_EntryData.Clear
    End If
End Sub

Private Sub Form_Load()
    Dim i As Integer

    BoardNo = 0
    Port = 1
    BAUD = 0
    Node = 1

    Combo_Board.Enabled = True
    Combo_Baud.Enabled = True
    Combo_Node.Enabled = False

    Combo_Board.ListIndex = 0
    Combo_Baud.ListIndex = 0
    Combo_Node.ListIndex = 0

    Btn_Initial.Enabled = True
    Btn_Shutdown.Enabled = False
    Btn_AddNode.Enabled = False
    Btn_LoadEDS.Enabled = False
    Btn_Remove.Enabled = False

    Call List_EntryData.Clear

    For i = 0 To 128
        ISADD(i) = 0
    Next
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call PISOCANCPM.ShutdownMaster(BoardNo, Port)
End Sub

Private Sub UpdateList()
        Dim PDO_Cnt As Integer, NMT_State As Integer
        Dim EMCYId As Integer, i As Integer, j As Integer
        Dim Id_List(10) As Integer
        Dim Temp_Str As String

        Dim IsNew As Integer, DLen As Integer
        Dim data(8) As Integer
                
        Call List_EntryData.Clear

        Ret = PISOCANCPM.NMTGetState(BoardNo, Port, Node, NMT_State, BlockMode)
        If Ret = 0 Then
            Temp_Str = "NMT State:"

            Select Case (NMT_State)
                Case &H4 ' Stop mode
                    Temp_Str = Temp_Str + " Stop mode"
                Case &H5 ' Operation mode
                    Temp_Str = Temp_Str + " Operation mode"
                Case &H7F ' Pre-operation mode
                    Temp_Str = Temp_Str + " Pre-operation mode"
            End Select
            List_EntryData.AddItem (Temp_Str)
        End If

        Ret = PISOCANCPM.GetEMCYID(BoardNo, Port, Node, EMCYId, BlockMode)
        If Ret = 0 Then
            If EMCYId <> 0 Then
                Ret = PISOCANCPM.ReadLastEMCY(BoardNo, Port, Node, IsNew, data(0), BlockMode)
                If (Ret = 0) Or (Ret = 15) Then
                    Temp_Str = "EMCY " + Hex(EMCYId) + " : "

                    For i = 0 To 7
                        Temp_Str = Temp_Str + Hex(data(i)) + " "
                    Next

                    List_EntryData.AddItem (Temp_Str)
                End If
            End If
        End If

        Ret = PISOCANCPM.GetRxPDOID(BoardNo, Port, Node, PDO_Cnt, Id_List(0), BlockMode)
        If Ret = 0 Then
            For i = 0 To PDO_Cnt - 1
                For j = 0 To 7
                    data(j) = 0
                Next
    
                DLen = 0
                Ret = PISOCANCPM.GetPDOLastData(BoardNo, Port, Id_List(i), IsNew, DLen, data(0), BlockMode)
                If (Ret = 0) Or (Ret = 15) Then
                    Temp_Str = "RxPDO " + Hex(Id_List(i)) + " : "

                    For j = 0 To (DLen - 1)
                        Temp_Str = Temp_Str + Hex(data(j)) + " "
                    Next

                    List_EntryData.AddItem (Temp_Str)
                End If
            Next
        End If

        Ret = PISOCANCPM.GetTxPDOID(BoardNo, Port, Node, PDO_Cnt, Id_List(0), BlockMode)
        If Ret = 0 Then
            For i = 0 To PDO_Cnt - 1
                For j = 0 To 7
                    data(j) = 0
                Next

                DLen = 0
                Ret = PISOCANCPM.GetPDOLastData(BoardNo, Port, Id_List(i), IsNew, DLen, data(0), BlockMode)
                If (Ret = 0) Or (Ret = 15) Then
                    Temp_Str = "TxPDO " + Hex(Id_List(i)) + " : "

                    For j = 0 To (DLen - 1)
                        Temp_Str = Temp_Str + Hex(data(j)) + " "
                    Next

                    List_EntryData.AddItem (Temp_Str)
                End If
            Next
        End If
    End Sub

Private Sub Timer1_Timer()
    Call UpdateList
End Sub
