VERSION 5.00
Object = "{A1F365CD-C4DA-44BC-B182-4495B8A753AB}#1.0#0"; "PISOCA~1.OCX"
Begin VB.Form Form1 
   Caption         =   "SDO_Read"
   ClientHeight    =   4935
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4470
   LinkTopic       =   "Form1"
   ScaleHeight     =   4935
   ScaleWidth      =   4470
   StartUpPosition =   3  'Windows Default
   Begin PISOCANCPMLib.PISOCANCPM PISOCANCPM 
      Left            =   3720
      Top             =   1320
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   794
      _StockProps     =   0
   End
   Begin VB.Frame Pal_SDO 
      Caption         =   "SDO Protocol"
      Height          =   3615
      Left            =   120
      TabIndex        =   10
      Top             =   1200
      Width           =   4215
      Begin VB.CommandButton Btn_Clear 
         Caption         =   "Clear"
         Height          =   375
         Left            =   2640
         TabIndex        =   17
         Top             =   3120
         Width           =   1455
      End
      Begin VB.TextBox Text_SubIndex 
         Height          =   375
         Left            =   1320
         MaxLength       =   2
         TabIndex        =   16
         Text            =   "00"
         Top             =   720
         Width           =   855
      End
      Begin VB.TextBox Text_Index 
         Height          =   375
         Left            =   120
         MaxLength       =   4
         TabIndex        =   15
         Text            =   "1000"
         Top             =   720
         Width           =   855
      End
      Begin VB.CommandButton Btn_ReadSDO 
         Caption         =   "Read SDO"
         Height          =   375
         Left            =   2640
         TabIndex        =   12
         Top             =   720
         Width           =   1455
      End
      Begin VB.ListBox List_SDOData 
         Height          =   1815
         ItemData        =   "Form1.frx":0000
         Left            =   120
         List            =   "Form1.frx":0002
         TabIndex        =   11
         Top             =   1200
         Width           =   3975
      End
      Begin VB.Label Label5 
         Caption         =   $"Form1.frx":0004
         Height          =   375
         Left            =   1200
         TabIndex        =   14
         Top             =   240
         Width           =   1095
      End
      Begin VB.Label Label4 
         Caption         =   $"Form1.frx":0027
         Height          =   375
         Left            =   120
         TabIndex        =   13
         Top             =   240
         Width           =   975
      End
   End
   Begin VB.CommandButton Btn_Initial 
      Caption         =   "Initial Master"
      Height          =   375
      Left            =   2880
      TabIndex        =   9
      Top             =   240
      Width           =   1455
   End
   Begin VB.CommandButton Btn_AddNode 
      Caption         =   "Add Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   8
      Top             =   720
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Remove 
      Caption         =   "Remove Node"
      Height          =   375
      Left            =   2880
      TabIndex        =   4
      Top             =   720
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Shutdown 
      Caption         =   "Shutdown"
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Top             =   240
      Width           =   1455
   End
   Begin VB.ComboBox Combo_Node 
      Height          =   315
      ItemData        =   "Form1.frx":0046
      Left            =   1080
      List            =   "Form1.frx":01C7
      TabIndex        =   2
      Top             =   840
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Baud 
      Height          =   315
      ItemData        =   "Form1.frx":04B2
      Left            =   1080
      List            =   "Form1.frx":04CE
      TabIndex        =   1
      Top             =   480
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Board 
      Height          =   315
      ItemData        =   "Form1.frx":0534
      Left            =   1080
      List            =   "Form1.frx":0568
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Node ID"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   840
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Board No"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

    Dim Board As Byte
    Dim Port As Byte
    Dim BAUD As Byte
    Dim Node As Byte

    Const BlockMode As Byte = 1

    Dim DelayTime As Integer
    Dim ret As Integer
    Dim errstr As String
    
Private Sub Btn_AddNode_Click()
    ret = PISOCANCPM.AddNode(Board, Port, Node, 1, DelayTime, 200, BlockMode)
    If ret <> 0 Then
        errstr = "AddNode Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = False
        Btn_Remove.Enabled = True
        Combo_Node.Enabled = False

        Pal_SDO.Enabled = True

    End If
End Sub

Private Sub Btn_Clear_Click()
    Call List_SDOData.Clear
End Sub

Private Sub Btn_Initial_Click()

    ret = PISOCANCPM.InitMaster(Board, Port, 0, BAUD, BlockMode)
    If ret <> 0 Then
        errstr = "Initial Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Combo_Board.Enabled = False
        Combo_Baud.Enabled = False
        Combo_Node.Enabled = True

        Btn_Initial.Enabled = False
        Btn_Initial.Visible = False
        Btn_Shutdown.Enabled = True

        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
    End If
End Sub

Private Sub Btn_ReadSDO_Click()
    Dim i As Integer, Index As Integer, RDlen As Long
    Dim SubIndex As Byte
    Dim RData(50) As Integer
    Dim DataStr As String

    Index = Val("&H" + Text_Index.Text)

    SubIndex = Val("&H" + Text_SubIndex.Text)

    ret = PISOCANCPM.SDOReadData(Board, Port, Node, Index, SubIndex, RDlen, RData(0), BlockMode)
    If ((ret <> 0) And (ret <> 25)) Then    ' 25 = CPM_Abort
        errstr = "SDO Read Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        DataStr = Right("0000" + Hex(Index), 4) + "-" + Right("00" + Hex(SubIndex), 2) + ": "
        For i = 0 To (RDlen - 1)
            DataStr = DataStr + Right("00" + Hex(RData(i)), 2) + " "
        Next

        If ret = 25 Then    ' 25 = CPM_Abort
            DataStr = DataStr + ": Read Abort"
        End If

        List_SDOData.AddItem (DataStr)
    End If
End Sub

Private Sub Btn_Remove_Click()
    ret = PISOCANCPM.RemoveNode(Board, Port, Node, BlockMode)
    If ret <> 0 Then
        errstr = "RemoveNode Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Btn_Remove.Enabled = False
        Btn_AddNode.Enabled = True
        Btn_AddNode.Visible = True
        Combo_Node.Enabled = True

        Pal_SDO.Enabled = False

    End If
End Sub

Private Sub Btn_Shutdown_Click()
    ret = PISOCANCPM.ShutdownMaster(Board, Port)
    If ret <> 0 Then
        errstr = "Shutdown Error, = " + Str(ret)
        MsgBox (errstr)
    Else
        Combo_Board.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Btn_Initial.Enabled = True
        Btn_Initial.Visible = True
        Btn_Shutdown.Enabled = False

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        Pal_SDO.Enabled = False
    End If
End Sub

Private Sub Combo_Baud_LostFocus()
    BAUD = Combo_Baud.ListIndex
    
    Select Case (BAUD)
        Case 0
            DelayTime = 15
        Case 1
            DelayTime = 7
        Case 2
            DelayTime = 3
        Case 3
        Case 4
            DelayTime = 1
        Case 5
        Case 6
        Case 7
            DelayTime = 0
    End Select
End Sub

Private Sub combo_board_LostFocus()
    Board = (Combo_Board.ListIndex)
End Sub

Private Sub Combo_Node_LostFocus()
    Node = Combo_Node.ListIndex + 1
End Sub

Private Sub Form_Load()
    Board = 0
    Port = 1
    BAUD = 0
    Node = 1

    Combo_Board.Enabled = True
    Combo_Baud.Enabled = True
    Combo_Node.Enabled = False

    Combo_Board.ListIndex = 0
    Combo_Baud.ListIndex = 0
    Combo_Node.ListIndex = 0

    Btn_AddNode.Enabled = False
    Btn_AddNode.Visible = True
    Btn_Remove.Enabled = False

    Pal_SDO.Enabled = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call PISOCANCPM.ShutdownMaster(Board, Port)
End Sub

